package em.jop.console;

import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeSet;

import em.jop.Console;

//EM 25/10/2008
public final class AllocView {
	public Map<String,AllocView> location = new HashMap<String,AllocView>();
	public TreeSet<AllocView> locationSorted;
	public boolean isExpended = false;
	public boolean hasCount = true;
	
	public String name;
	public long count = 0;
	public long countGC = 0;
	
	public long countMark = 0;
	public long countGCMark = 0;
	
	//EM 29/10/2008
	public String methodPath;
	public String methodName;
	public String methodAttr;
	public String methodRet;
	
	public AllocView(String aName){
		name = aName;
		//EM 29/10/2008 : name can be a method descr
		String methodSign = name;
		int aPosBeg = 0,aPosEnd = 0;
		if((aPosEnd = methodSign.indexOf(".")) < 0){
			return;
		}
		String aSub = methodSign.substring(aPosBeg,aPosEnd);
		if((aPosEnd = aSub.lastIndexOf("/")) < 0){
			return;
		}
		aPosEnd++;
		methodPath = methodSign.substring(aPosBeg,aPosEnd);
		aPosBeg = aPosEnd;
		if((aPosEnd = methodSign.indexOf("(",aPosEnd)) < 0){
			//??
			return;
		}
		methodName = methodSign.substring(aPosBeg,aPosEnd);
		aPosBeg = aPosEnd;
		if((aPosEnd = methodSign.indexOf(")",aPosEnd)) < 0){
			//??
			return;
		}
		aPosEnd++;
		methodAttr = methodSign.substring(aPosBeg,aPosEnd).replaceAll("\\(\\)", "( )");
		methodRet = methodSign.substring(aPosEnd);
	}
	
	//EM 26/10/2008
	public void sortRecurse(Comparator aComp) {
		Object[] aAs = location.values().toArray();
		for(int a = 0;a < aAs.length;a++){
			AllocView aA = ((AllocView)aAs[a]);
			aA.sortRecurse(aComp);
		}
		locationSorted = new TreeSet<AllocView>(aComp);
		locationSorted.addAll(location.values());
	}

	//EM 26/10/2008
	public void setMark() {
		countMark = count;
		countGCMark = countGC;

		Object[] aAs = location.values().toArray();
		for(int a = 0;a < aAs.length;a++){
			AllocView aA = ((AllocView)aAs[a]);
			aA.setMark();
		}
	}

	//EM 26/10/2008
	public void buildCalleePopulate(MethodView aRootM,Comparator aComp) {
		MethodView aRM = aRootM.subMethods.get(name);
		if(aRM != null){
			Object[] aMs = aRM.subMethods.values().toArray();
			for(int m = 0;m < aMs.length;m++){
				MethodView aSubM = ((MethodView)aMs[m]);
				AllocView aSubA = location.get(aSubM.methodSign);
				if(aSubA == null){
					//Add
					AllocView aSSubA= new AllocView(aSubM.methodSign);
					aSSubA.hasCount = false;
					location.put(aSubM.methodSign, aSSubA);
				}
			}
			locationSorted = new TreeSet<AllocView>(aComp);
			locationSorted.addAll(location.values());
		}
	}

}
