package em.jop.console;

import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeSet;

public final class MethodView {
	public Map<String,MethodView> subMethods = new /*Tree*/HashMap<String,MethodView>();
	public TreeSet<MethodView> subMethodsSorted;
	public boolean isExpended = false; 

	public String methodSign;
	//EM 29/10/2008
	public String methodPath;
	public String methodName;
	public String methodAttr;
	public String methodRet;
	
	public long count = 0;
	//EM 19/10/2008
	public long countSubMax = 0;
	public long timeSpent = 0;
	public long timeSubSpent = 0;
	//EM 19/10/2008
	public long timeInSpent = 0;
	public long timeInSpentSubMax = 0;
	//EM 06/10/2008
	public long timeJopSpent = 0;
	//EM 18/10/2008
	public long timeJopSpentTot = 0;

	//EM 12/10/2008
	public long countMark = 0;
	//EM 19/10/2008
	public long countSubMaxMark = 0;
	//public long timeStartMark = 0;
	public long timeSpentMark = 0;
	public long timeSubSpentMark = 0;
	//EM 19/10/2008
	public long timeInSpentMark = 0;
	public long timeInSpentSubMaxMark = 0;
	public long timeJopSpentMark = 0;
	public long timeJopSpentTotMark = 0;
	
	public MethodView(String aMethodSign){
		methodSign = aMethodSign;
		//EM 29/10/2008
		int aPosBeg = 0,aPosEnd = 0;
		if((aPosEnd = methodSign.indexOf(".")) < 0){
			return;
		}
		String aSub = methodSign.substring(aPosBeg,aPosEnd);
		if((aPosEnd = aSub.lastIndexOf("/")) < 0){
			return;
		}
		aPosEnd++;
		methodPath = methodSign.substring(aPosBeg,aPosEnd);
		aPosBeg = aPosEnd;
		if((aPosEnd = methodSign.indexOf("(",aPosEnd)) < 0){
			//??
			return;
		}
		methodName = methodSign.substring(aPosBeg,aPosEnd);
		aPosBeg = aPosEnd;
		if((aPosEnd = methodSign.indexOf(")",aPosEnd)) < 0){
			//??
			return;
		}
		aPosEnd++;
		methodAttr = methodSign.substring(aPosBeg,aPosEnd).replaceAll("\\(\\)", "( )");
		methodRet = methodSign.substring(aPosEnd);
	}
	
	//EM 19/10/2008
	public boolean isWait(){
		return methodSign.endsWith(".WAITING") || methodSign.endsWith(".sleep");

	}
	//EM 11/10/2008 : recursive calculation / sorting
	public void calcSortRecurse(Comparator aComp) {
		Object[] aMs = subMethods.values().toArray();
		timeSubSpent = 0;
		timeInSpentSubMax = 0;
		countSubMax = 0;
		timeJopSpentTot = timeJopSpent;
		for(int m = 0;m < aMs.length;m++){
			MethodView aM = ((MethodView)aMs[m]);
			aM.calcSortRecurse(aComp);
			timeSubSpent += aM.timeSpent;
			//propagate jop-time (was reset at update time)
			//EM 18/10/2008 : calc tot
			timeJopSpentTot += aM.timeJopSpentTot;
			timeInSpentSubMax = (timeInSpentSubMax > aM.timeInSpentSubMax || aM.isWait())?timeInSpentSubMax:aM.timeInSpentSubMax;
			countSubMax = (countSubMax > aM.countSubMax || aM.isWait())?countSubMax:aM.countSubMax;
		}
		//Build correction with jop-time
		//EM 18/10/2008 : use tot
		timeSpent -= timeJopSpentTot;
		//For not-ended methods, use subspent time 
		if(timeSpent <= timeSubSpent){
			timeSpent = timeSubSpent;
		}
		//EM 19/10/2008
		timeInSpent = timeSpent - timeSubSpent;
		timeInSpentSubMax = (timeInSpentSubMax > timeInSpent)?timeInSpentSubMax:timeInSpent;
		countSubMax = (countSubMax > count)?countSubMax:count;

		subMethodsSorted = new TreeSet<MethodView>(aComp);
		subMethodsSorted.addAll(subMethods.values());
	}

	//EM 12/10/2008
	public void sortRecurse(Comparator aComp) {
		Object[] aMs = subMethods.values().toArray();
		for(int m = 0;m < aMs.length;m++){
			MethodView aM = ((MethodView)aMs[m]);
			aM.sortRecurse(aComp);
		}
		subMethodsSorted = new TreeSet<MethodView>(aComp);
		subMethodsSorted.addAll(subMethods.values());
	}
	
	//EM 12/10/2008
	public void setMark() {
		countMark = count;
		//EM 19/10/2008
		countSubMaxMark = countSubMax;
		timeSpentMark = timeSpent;
		timeSubSpentMark = timeSubSpent;
		timeJopSpentMark = timeJopSpent;
		//EM 18/10/2008
		timeJopSpentTotMark = timeJopSpentTot;
		//EM 19/10/2008
		timeInSpentMark = timeInSpent;
		timeInSpentSubMaxMark = timeInSpentSubMax;

		Object[] aMs = subMethods.values().toArray();
		for(int m = 0;m < aMs.length;m++){
			MethodView aM = ((MethodView)aMs[m]);
			aM.setMark();
		}
	}
	
	//EM 28/10/2008
	public void initRecurse(){
		count = 0;
		countMark = 0;
		countSubMax = 0;
		countSubMaxMark = 0;
		timeSpent = 0;
		timeSpentMark = 0;
		timeInSpent = 0;
		timeInSpentMark = 0;
		timeInSpentSubMax = 0;
		timeInSpentSubMaxMark = 0;
		timeJopSpent = 0;
		timeJopSpentMark = 0;
		timeJopSpentTot = 0;
		timeJopSpentTotMark = 0;
		timeSubSpent = 0;
		timeSubSpentMark = 0;
		Object[] aMSubs = subMethods.values().toArray();
		for(int m = 0;m < aMSubs.length;m++){
			MethodView aMSub = (MethodView)aMSubs[m];
			aMSub.initRecurse();
		}
	}

	//EM 28/10/2008
	public void addRecurse(MethodView aM){
		MethodView aMIn = subMethods.get(aM.methodSign);
		if(aMIn == null){
			aMIn = new MethodView(aM.methodSign);
			subMethods.put(aM.methodSign, aMIn);
		}
		aMIn.count += aM.count;
		aMIn.countMark += aM.countMark;
		aMIn.countSubMax += aM.countSubMax;
		aMIn.countSubMaxMark += aM.countSubMaxMark;
		aMIn.timeSpent += aM.timeSpent;
		aMIn.timeSpentMark += aM.timeSpentMark;
		aMIn.timeInSpent += aM.timeInSpent;
		aMIn.timeInSpentMark += aM.timeInSpentMark;
		aMIn.timeInSpentSubMax += aM.timeInSpentSubMax;
		aMIn.timeInSpentSubMaxMark += aM.timeInSpentSubMaxMark;
		aMIn.timeJopSpent += aM.timeJopSpent;
		aMIn.timeJopSpentMark += aM.timeJopSpentMark;
		aMIn.timeJopSpentTot += aM.timeJopSpentTot;
		aMIn.timeJopSpentTotMark += aM.timeJopSpentTotMark;
		aMIn.timeSubSpent += aM.timeSubSpent;
		aMIn.timeSubSpentMark += aM.timeSubSpentMark;
		Object[] aMSubs = aM.subMethods.values().toArray();
		for(int m = 0;m < aMSubs.length;m++){
			MethodView aMSub = (MethodView)aMSubs[m];
			aMIn.addRecurse(aMSub);
		}
	}

	//EM 18/10/2008 : build callee from root
	public void buildCallee(MethodView aCalleeRootM,Comparator aComp) {
		buildCalleeRecurse(aCalleeRootM,null);
		//Sort 2 levels
		aCalleeRootM.subMethodsSorted = new TreeSet<MethodView>(aComp);
		aCalleeRootM.subMethodsSorted.addAll(aCalleeRootM.subMethods.values());
		Object[] aMs = aCalleeRootM.subMethods.values().toArray();
		for(int m = 0;m < aMs.length;m++){
			MethodView aSubM = ((MethodView)aMs[m]);
			aSubM.buildCalleePopulate(aCalleeRootM, aComp);
		}
	}
	//EM 18/10/2008
	public void buildCalleeRecurse(MethodView aCalleeRootM,MethodView aCaller) {
		//Is this method in the callee ?
		MethodView aM = aCalleeRootM.subMethods.get(methodSign);
		if(aM == null){
			//Add it in
			aCalleeRootM.subMethods.put(methodSign, aM = new MethodView(methodSign));
		}
		//Update values
		aM.count += count;
		aM.timeSpent += timeSpent - timeSubSpent;
		aM.timeJopSpent += timeJopSpent;

		aM.countMark += countMark;
		aM.timeSpentMark += timeSpentMark - timeSubSpentMark;
		aM.timeJopSpentMark += timeJopSpentMark;
		
		//Build callee tree
		if(aCaller != null){
			if(methodSign.equals(aCaller.methodSign)){
				//Avoid infinite loop
				if(aM.subMethods.get("RECURSIVE") == null){
					aM.subMethods.put("RECURSIVE", new MethodView("RECURSIVE"));
				}
			}
			else{
				//Add the caller as sub
				if(aM.subMethods.get(aCaller.methodSign) == null){
					aM.subMethods.put(aCaller.methodSign,new MethodView(aCaller.methodSign));
				}
			}
		}
		
		Object[] aMs = subMethods.values().toArray();
		for(int m = 0;m < aMs.length;m++){
			MethodView aSubM = ((MethodView)aMs[m]);
			aSubM.buildCalleeRecurse(aCalleeRootM, aM);
		}
	}

	public void buildCalleePopulate(MethodView aCalleeRootM,Comparator aComp) {
		Object[] aMs = subMethods.values().toArray();
		for(int m = 0;m < aMs.length;m++){
			MethodView aSubM = ((MethodView)aMs[m]);
			MethodView aSubRoot = aCalleeRootM.subMethods.get(aSubM.methodSign);
			//Recusive virtual method isn't in root
			if(aSubRoot != null){
				aSubM.count += aSubRoot.count;
				aSubM.timeSpent += aSubRoot.timeSpent;
				aSubM.timeJopSpent += aSubRoot.timeJopSpent;

				aSubM.countMark += aSubRoot.countMark;
				aSubM.timeSpentMark += aSubRoot.timeSpentMark;
				aSubM.timeJopSpentMark += aSubRoot.timeJopSpentMark;
				
				Object[] aSMs = aSubRoot.subMethods.values().toArray();
				for(int s = 0;s < aSMs.length;s++){
					MethodView aSSubM = ((MethodView)aSMs[s]);
					aSubM.subMethods.put(aSSubM.methodSign, new MethodView(aSSubM.methodSign));
				}
			}
		}
		subMethodsSorted = new TreeSet<MethodView>(aComp);
		subMethodsSorted.addAll(subMethods.values());
	}
}
